# Generated by Django 2.2.25 on 2022-05-02 16:56

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        ("judge", "0122_auto_20220425_1202"),
    ]

    operations = [
        migrations.AlterModelOptions(
            name="problem",
            options={
                "permissions": (
                    ("see_private_problem", "See hidden problems"),
                    ("edit_own_problem", "Edit own problems"),
                    ("edit_all_problem", "Edit all problems"),
                    ("edit_public_problem", "Edit all public problems"),
                    ("clone_problem", "Clone problem"),
                    ("change_public_visibility", "Change is_public field"),
                    ("change_manually_managed", "Change is_manually_managed field"),
                    ("see_organization_problem", "See organization-private problems"),
                    ("suggest_problem_changes", "Suggest changes to problem"),
                ),
                "verbose_name": "problem",
                "verbose_name_plural": "problems",
            },
        ),
        migrations.CreateModel(
            name="VolunteerProblemVote",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("time", models.DateTimeField(auto_now_add=True)),
                (
                    "knowledge_points",
                    models.PositiveIntegerField(
                        help_text="Points awarded by knowledge difficulty",
                        verbose_name="knowledge points",
                    ),
                ),
                (
                    "thinking_points",
                    models.PositiveIntegerField(
                        help_text="Points awarded by thinking difficulty",
                        verbose_name="thinking points",
                    ),
                ),
                ("feedback", models.TextField(blank=True, verbose_name="feedback")),
                (
                    "problem",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="volunteer_user_votes",
                        to="judge.Problem",
                    ),
                ),
                (
                    "types",
                    models.ManyToManyField(
                        help_text="The type of problem, as shown on the problem's page.",
                        to="judge.ProblemType",
                        verbose_name="problem types",
                    ),
                ),
                (
                    "voter",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="volunteer_problem_votes",
                        to="judge.Profile",
                    ),
                ),
            ],
            options={
                "verbose_name": "volunteer vote",
                "verbose_name_plural": "volunteer votes",
                "unique_together": {("voter", "problem")},
            },
        ),
    ]
